Option CNS = conopt ;
Option MCP = Path ;
*Option MCP = Miles ;
* Upward sloping capital and labour supply curve???
$ontext
set a / lab, aus, nzl, row / ;

Table Data(a,a)
     aus       nzl      row
lab  715.574   81.827   150.262
aus  343.883   5.248    45.988
nzl  2.390     35.801   2.766
row  143.263   10.463   498.379
;
$offtext

*set io1 / i1*i9 / ;
*alias (io1, io2) ;
set io1 / DAus, Dnzl, Drow, SFac, Kaus, Knzl, Krow / ;
set io2 / Oaus, Onzl, Orow, Caus, Cnzl, Crow/ ;


Parameter
InpDataPQ(io1,io2), InpDataPP(io1,io2), InpDataPV(io1,io2),
OutDataPQ(io1,io2), OutDataPP(io1,io2), OutDataPV(io1,io2),
ChaDataPQ(io1,io2), ChaDataPP(io1,io2), ChaDataPV(io1,io2);

Parameter
InpDataUQ(io1,io2), InpDataUP(io1,io2), InpDataUV(io1,io2),
OutDataUQ(io1,io2), OutDataUP(io1,io2), OutDataUV(io1,io2),
ChaDataUQ(io1,io2), ChaDataUP(io1,io2), ChaDataUV(io1,io2);

Parameter
IO_Q(io1,io2), IO_P(io1,io2), IO_V(io1,io2),
OO_Q(io1,io2), OO_P(io1,io2), OO_V(io1,io2),
CO_Q(io1,io2), CO_P(io1,io2), CO_V(io1,io2);

scalar flag_ausrec, flag_nzlrec ;
flag_ausrec = 0 ; flag_nzlrec = 0 ;

*set a / A1*A10 / ;
set a / LabC, KausC, KnzlC, KrowC, TC, Cost, QoS, cbar, Out, PoS2, ybar, L, K, ntK, ptK, Ytot

  / ;
alias (a, a1, a2, b)
parameter Check(a,b);

***********************************************************************************************************
* Production side initialisation

set i region from which input is sourced / aus, nzl, row / ;
*set r region in which input is used      / aus, nzl, row / ;
alias (i, i1, r, r1, c, c1) ;

Parameter DivShare(r) ;
DivShare(r) = 1 ;
DivShare('Aus') = 0.3 ;
DivShare('Nzl') = 0.3 ;

Parameter SupShare(r) ;
SupShare(r) = 0 ;

Parameters qkbar(i,r), thetak(i,r), thetaKK(i,r), thetaKKK(i,r), taxk(i,r), tdk(i,r), cred(i,r), taxl(r) ;
Parameters vlbar(r), qlbar(r), plbar(r), thetal(r), thetaLL(r), thetaLLL(r), cbar(r) ;
Parameters rho(r), sigma(r), gamma(r) ;


cred(i,r) = 0 ;

Parameters
*tim* vlbar(r) / aus 200, nzl 200, row 200 /
vlbar(r) / aus 1143.069, nzl 131.383, row 65965.930 /
plbar(r) / aus 1,       nzl 1,      row 1 / ;


Table vkbar(i,r)
*tim*     aus       nzl      row
*aus  200       200      100
*nzl  100       300      100
*row  100       200      200
*         aus          nzl          row
*aus      3.439        0.087        0.460
*nzl      0.020        0.358        0.028
*row      1.437        0.070        5.058
*    aus              nzl            row
*aus 43.883           8.664          45.999
*nzl 1.957            35.801         2.767
*row 143.697          7.048          29505.757
    aus              nzl            row
aus 143.468          4.191          16.580
nzl 1.102            12.411         0.996
row 37.175           2.994          10595.672
;

* timtimtim
*tim*    vkbar('nzl','aus') = 1.102 + 1.28 ; vkbar('row','aus') = 37.175 - 1.28 ;
*tim*    vkbar('aus','nzl') = 4.191 - 0.389; vkbar('row','nzl') = 2.994 + 0.389;





Table pkbar(i,r)
*tim*     aus       nzl      row
*aus  1.00      2.00     1.00
*nzl  1.00      1.00     1.00
*row  1.00      2.00     1.00
         aus          nzl          row
aus      1.00         1.28         1.10
nzl      1.30         1.00         1.10
row      1.30         1.28         1.00
;

*cred('aus','aus') = -0.00 ;


taxk(i,r) = pkbar(i,r) - 1 ;
taxl(r)   = plbar(r) - 1 ;

tdk(i,r) = taxk(i,r) ;
tdk('Aus','Aus') = 0.3 ;
tdk('Nzl','Nzl') = 0.28 ;

qlbar(  r) = vlbar(r)    / plbar(  r) ;
qkbar(i,r) = vkbar(i,r)  / pkbar(i,r) ;

cbar(r) =           plbar(  r)*qlbar(  r)
         + sum[ i , pkbar(i,r)*qkbar(i,r) ] ;

sigma(r) = 0.85    ;
sigma('Aus') = 10    ;

*sigma = 0.01    ;
rho(r) = 1 - 1/sigma(r) ;
gamma(r) = 1 - sigma(r) ;
thetal(  r) = plbar(  r) * qlbar(  r) / cbar(r) ;
thetak(i,r) = pkbar(i,r) * qkbar(i,r) / cbar(r) ;
thetaLL(r)   = [ cbar(r) / ( plbar(  r) * qlbar(  r) ) ]**(1/gamma(r));
thetaKK(i,r) = [ cbar(r) / ( pkbar(i,r) * qkbar(i,r) ) ]**(1/gamma(r));

thetaLLL(r) =   [ (  cbar(r) / (plbar(r)   * qlbar(r)) ) ** (1/gamma(r)) ] * (1 + taxl(r)) ;
thetaKKK(i,r) = [ (  cbar(r) / (pkbar(i,r) * qkbar(i,r)) ) ** (1/gamma(r)) ] * (1 + taxk(i,r)) ;

***********************************************************************************************************
* Consumption side

*     aus     nzl    row     aus     nzl    row
*aus  483.391 5.667  141.417 430.124 3.096  141.417
*nzl  4.344   58.970 16.972  3.865   32.217 16.972
*row  122.338 17.149 219.841 108.857 9.369  219.841

*     aus     nzl    row
*aus  913.515 8.763  282.834
*nzl  8.209   91.187 33.944
*row  231.195 26.518 439.682

Parameters qcbar(r,c), thetac(r,c), taxc(r,c), alpha(r,c) ;
Parameters ybar(c), taxY(c) ;
Scalar rhoc, sigmac ;

taxY('Aus') = 0.45 ;
taxY('nzl') = 0.33 ;
taxY('row') = 0.3 ;

Parameter taxkg(c), taxsup(r) ;

taxkg(r) = taxy(r) ;
taxsup(r) = taxy(r) ;




Table vcbar(r,c)
*tim*            aus                nzl                row
*aus         171.4285714        257.1428571        171.4285714
*nzl         257.1428571        385.7142857        257.1428571
*row         171.4285714        257.1428571        171.4285714
*         aus          nzl          row
*aus      11.916       0.088        2.899
*nzl      0.082        1.314        0.351
*row      2.312        0.265        6.803
*    aus              nzl             row
*aus 1191.568         8.762           294.097
*nzl 8.209            131.399         35.325
*row 231.195          26.518          76675.837
    aus              nzl             row
aus 1074.312         8.762           241.739
nzl 8.209            111.840         30.930
row 231.195          26.518          76321.465
;

*tim*    vcbar('nzl','nzl') = vcbar('nzl','nzl') + 1.28/(1+tdk('nzl','aus')) ;  vcbar('nzl','row') = vcbar('nzl','row') - 1.28/(1+tdk('nzl','aus')) ;
*tim*    vcbar('aus','aus') = vcbar('aus','aus') - 0.389/(1+tdk('aus','nzl')) ; vcbar('aus','row') = vcbar('aus','row') + 0.389/(1+tdk('aus','nzl')) ;


Table pcbar(r,c)
     aus       nzl      row
aus  1.00      1.00     1.00
nzl  1.00      1.00     1.00
row  1.00      1.00     1.00
;

*pcbar(r,c)   =  [ vlbar(r) + sum[ i1 , vkbar(i1,r) ] ] / [qlbar(r) +sum[ i1 , qkbar(i1,r) ]] ;


taxc(r,c) = pcbar(r,c) - 1 ;

qcbar(r,c) = vcbar(r,c)  / pcbar(r,c) ;

ybar(c) = sum[ r , pcbar(r,c)*qcbar(r,c) ] ;

sigmac = 2     ;
rhoc = 1 - 1/sigmac ;
thetac(r,c) = pcbar(r,c) * qcbar(r,c) / ybar(c) ;
alpha(r,c) = vcbar(r,c) / ybar(c) ;

***********************************************************************************************************
Variable TQoS, TCost, Rk(i), Rl(r) ;
Positive Variable QoS(r), QkD(i,r), PkD(i,r), QlD(r), PlD(r), Cost(r), PkS(i,r), PoS2(r), Out(r) ;
Equations Eq_TQoS, Eq_TCost, Eq_QoS(r), Eq_Cost(r), Eq_PkD(i,r), Eq_QkS_M(i), Eq_QkS_F, Eq_QlS_F(r), Eq_PoS2(r), Eq_Cst(r), Eq_QkD(i,r), Eq_QlD(r), Eq_Out(r), Eq_QoS2, Eq_QoSfix(r) ;

Variable TV;
Positive variables V(c), QoD(r,c), PoD(r,c), Y(c), PoS(r), Pu(c), Cst(r) ;
Equations Eq_TV, Eq_V(c), Eq_BC(r), Eq_PoD(r,c), Eq_QoD(r,c), Eq_Pu(c), Eq_Y(c), Eq_PoS(r) ;

Parameter para(r), yfix(r), psfix(c), qosfix(r) ;
para(r) = 1 ; yfix(r) = ybar(r) ; psfix(c) = 1 ; qosfix(r) = 1 ;

***********************************************************************************************************
* Production side



Eq_PoS2(r)..
PoS2(r)*QoS(r) =e= Cost(r) ;

Eq_QlS_F(r)..
QlD(r) =e= qlbar(r)

* Capital mobility control set and equation
* Capital trading block mapping


variable PkS2(i,r), QkS(i,r) ;
equation Eq_Pks_N(i,r), Eq_QkS(i,r) ;
PkS2.lo(i,r) = 0.0001 ;
PkS2.l(i,r)  = 1 ;

Eq_PkD(i,r)..
PkS2(i,r) =e= PkD(i,r) - taxk(i,r)
 - DivShare(r)*cred(i,r)$[ord(i) ne ord(r)]
;




***************************
parameter sCET(i), rCET(i), oCET(i,r), ktot(i), vtot(i) ;
equations Eq_PkDCET(i,r), Eq_PkSCET(i,r), Eq_O(i) ;
variable PkSCET(i,r), O(i), QkSCET(i,r) ;
O.lo(i) = 0.0001 ; O.l(i) = 1 ;

ktot(i) = sum[ r1 , qkbar(i,r1) ] ;
vtot(i) = sum[ r1 , vkbar(i,r1) ] ;
sCET(r) = 10000 +  1 ;
oCET(i,r) = qkbar(i,r) / ktot(i) ;
sCET('Aus') = 3 ;
sCET('Nzl') = 5 ;


Eq_PkSCET(i,r)..
QkS(i,r) =e=
                ktot(i)
                * oCET(i,r) *
                ((PkS2(i,r)/[pkbar(i,r)-taxk(i,r)])**(sCET(i)-1))
                /
                sum[ r1 , oCET(i,r1) * ((PkS2(i,r1)/[pkbar(i,r)-taxk(i,r)])**(sCET(i)-1)) ]
;






Eq_PkDCET(i,r)..
PkSCET(i,r) =e= PkD(i,r) - taxk(i,r) - DivShare(r)*cred(i,r) ;



*Eq_PkSCET(i,r)..
*QkS(i,r) =e=   ;

***************************


Eq_QkS(i,r)..
QkS(i,r) =e= QkD(i,r) ;




****************************************************************************************************
Parameter thetaL2(r), thetaK2(i,r), thetaL3(r), thetaK3(i,r) ;
Equation Eq_Cst2(r), Eq_QkD3(i,r), Eq_QlD3(r), Eq_QoS3(r) ;
Variable QoS3, QlD3(r), QkD3(i,r) ;


thetaL3(r)   =     plbar(r)   * qlbar(r)   / cbar(r) ;
thetaK3(i,r) =     pkbar(i,r) * qkbar(i,r) / cbar(r) ;



Eq_Cst2(r)..
Cost(r) =e=  [
                          thetaL3(r)  *([PlD(r)  /plbar(r)   ]  **(1-sigma(r)))
               + sum[ i , thetaK3(i,r)*([PkD(i,r)/pkbar(i,r) ]**(1-sigma(r)))  ]
            ]**(1/(1-sigma(r)))*QoS(r)  ;

Eq_QoS3(r)..
QoS3(r) =e=
         sum[ c , qcbar(r,c) ] *
                     [
                        [
                            sum[ i , thetaK3(i,r) * ( [QkD(i,r) / qkbar(i,r)]**rho(r) ) ]
                                 +   thetaL3(  r) * ( [QlD(  r) / qlbar(  r)]**rho(r) )
                        ]
                     ]**(1/rho(r)) ;

Eq_QlD3(r)..
Qld(r) =e= qlbar(r) * QoS(r) / sum[ c , qcbar(r,c) ] *
           [( PoS(r) * plbar(r) ) / ( PlD(r) ) ] ** sigma(r) ;

Eq_QkD3(i,r)..
Qkd(i,r) =e= qkbar(i,r) * QoS(r) / sum[ c , qcbar(r,c) ] *
           [( PoS(r) * pkbar(i,r) ) / ( PkD(i,r) ) ] ** sigma(r) ;
****************************************************************************************************
Parameters oL(r), oK(r), oTT(r), oRoW(r), oAus(r), oNzl(r);
Parameters pc1bar(r), pc2bar(r), pc3bar(r);
Parameters sLK(r), sRoW(r), sTT(r) ;
Equations Eq_Cost0(r), Eq_Cost1(r), Eq_Cost2(r), Eq_Cost3(r) ;
Variables Cost0(r), Cost1(r)   , Cost2(r)   , Cost3(r) ;
Equations Eq_XL(r), Eq_XK(r), Eq_XTT(r), Eq_XRoW(r), Eq_XAus(r), Eq_XNzl(r) ;
Variables XL(r)   , XK(r)   , XTT(r)   , XRoW(r)   , XAus(r),    XNzl(r) ;


sLK(r)=0.85; sRoW(r)=0.85; sTT(r)=0.85;
sLK('Aus')=0.85; sRoW('Aus')=10; sTT('Aus')=0.85;
*sLK('Aus')=0.85; sRoW('Nzl')=10; sTT('Nzl')=10;
sRoW('Nzl') = 10 ;
sRoW('RoW') = 10 ;









*calibrated levels
pc1bar(r)=1; pc2bar(r)=1; pc3bar(r)=1;
oL(r)   = thetaL3(r) ;
oK(r)   = 1 - oL(r) ;
oRoW(r) = vkbar('RoW',r) / [vkbar('Aus',r) + vkbar('Nzl',r) + vkbar('RoW',r)] ;
oTT(r)  = 1 - oRoW(r) ;
oAus(r) = vkbar('Aus',r) / [vkbar('Aus',r) + vkbar('Nzl',r) ] ;
oNzl(r) = 1 - oAus(r) ;

Cost1.lo(r) = 0.00001; Cost2.lo(r) = 0.00001; Cost3.lo(r) = 0.00001;
Cost1.l(r) = 1; Cost2.l(r) = 1; Cost3.l(r) = 1 ;
XL.lo(r) = 0.00001; XK.lo(r) = 0.00001; XTT.lo(r) = 0.00001; XRoW.lo(r) = 0.00001; XAus.lo(r) = 0.00001; XNzl.lo(r) = 0.00001;
XL.l(r) = 1; XK.l(r) = 1; XTT.l(r) = 1; XRoW.l(r) = 1; XAus.l(r) = 1; XNzl.l(r) = 1;

Eq_Cost0(r)..
Cost(r) =e= QoS(r)*Cost1(r) ;

Eq_Cost1(r)..
Cost1(r) =e= [oL(r)*[PlD(r)   /plbar(r)]**(1-sLK(r))
            + oK(r)*[Cost2(r) /pc2bar(r)]**(1-sLK(r))] ** (1/(1-sLK(r))) ;

Eq_Cost2(r)..
Cost2(r) =e= [oTT(r)*[Cost3(r)       /pc3bar(r)]     **(1-sRoW(r))
            + oRoW(r)*[PkD('row',r)  /pkbar('row',r)]**(1-sRoW(r))]  ** (1/(1-sRoW(r))) ;

Eq_Cost3(r)..
Cost3(r) =e= [oAus(r)*[PkD('Aus',r)/pkbar('Aus',r)]**(1-sTT(r))
            + oNzl(r)*[PkD('Nzl',r)/pkbar('Nzl',r)]**(1-sTT(r))]  ** (1/(1-sTT(r))) ;

Eq_XL(r)..
XL(r) =e= qlbar(r)         * QoS(r) / sum[ c , qcbar(r,c) ]
                           * [(PlD(r)/plbar(r))**(-sLK(r))]
                           * [Cost1(r)**sLK(r)] ;


Eq_XRoW(r)..
XRoW(r) =e= qkbar('RoW',r) * QoS(r) / sum[ c , qcbar(r,c) ]
                           * [(PkD('Row',r)/pkbar('RoW',r))**(-sRoW(r))]
                           * [Cost1(r)**sLK(r)]
                           * [Cost2(r)**(sRoW(r) - sLK(r))] ;

Eq_XAus(r)..
XAus(r) =e= qkbar('Aus',r) * QoS(r) / sum[ c , qcbar(r,c) ]
                           * [(PkD('Aus',r)/pkbar('Aus',r))**(-sTT(r))]
                           * [Cost1(r)**sLK(r)]
                           * [Cost2(r)**(sRoW(r) - sLK(r))]
                           * [Cost3(r)**(sTT(r)  - sRoW(r))];

Eq_XNzl(r)..
XNzl(r) =e= qkbar('Nzl',r) * QoS(r) / sum[ c , qcbar(r,c) ]
                           * [(PkD('Nzl',r)/pkbar('Nzl',r))**(-sTT(r))]
                           * [Cost1(r)**sLK(r)]
                           * [Cost2(r)**(sRoW(r) - sLK(r))]
                           * [Cost3(r)**(sTT(r)  - sRoW(r))];

Equations Eq_AggCap(i,r), Eq_AggLab(r) ;

Eq_AggCap(i,r)..
QkD(i,r) =e= XRoW(r)$[ord(i) eq 3]
           + XNzl(r)$[ord(i) eq 2]
           + XAus(r)$[ord(i) eq 1]
;

Eq_AggLab(r)..
QlD(r) =e= XL(r) ;



****************************************************************************************************
* Consumption side

Eq_PoD(r,c)..
PoS(r) =e= PoD(r,c) - taxc(r,c) ;

Eq_QoD(r,c)..
QoD(r,c) =e= alpha(r,c) * Y(c) / PoD(r,c) ;

****************************************************************************************************

Equations Eq_PoSTim(r), Eq_QoSTim(r), Eq_YTim(r), Eq_YDTim(r), Eq_YGTim(r) ;
Variables YG(c), YD(c) ;

Eq_PoSTim(r)..
PoS(r)*QoS(r) =e= Cost(r) ;

Eq_QoSTim(r)..
QoS(r) =e= sum[ c , QoD(r,c) ] ;

Eq_YTim(r)..
Y(r) =e= YD(r) + YG(r) ;

Eq_YDTim(r)..
YD(r) =e=
*Total Labour income
                (1-taxy(r))*( Pld(r)*Qld(r) )
*Total capital income from non-super, dividend
                +(1-taxy(r))* (sum[ r1 ,  (1-SupShare(r1))*(DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ]
                + sum[ r1 , -(1-SupShare(r1))*(DivShare(r1))*(cred(r,r1))*Qkd(r,r1) ])
*Total capital income from super, dividend
                +(1-taxsup(r))* (sum[ r1 ,  (SupShare(r1))*(DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ]
                + sum[ r1 , -(SupShare(r1))*(DivShare(r1))*(cred(r,r1))*Qkd(r,r1) ])
*Total capital income from non-super, non-dividend
                +(1-taxkg(r))* (sum[ r1 ,  (1-SupShare(r1))*(1-DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ])
*Total capital income from super, non-dividend
                +(1-taxsup(r))* (sum[ r1 ,  (SupShare(r1))*(1-DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ])
;

Eq_YGTim(r)..
YG(r) =e=
*Total Labour income
                (taxy(r))*( Pld(r)*Qld(r) )
*Total capital income from non-super, dividend
                +(taxy(r))* (sum[ r1 ,  (1-SupShare(r1))*(DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ]
                + sum[ r1 , -(1-SupShare(r1))*(DivShare(r1))*(cred(r,r1))*Qkd(r,r1) ])
*Total capital income from super, dividend
                +(taxsup(r))* (sum[ r1 ,  (SupShare(r1))*(DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ]
                + sum[ r1 , -(SupShare(r1))*(DivShare(r1))*(cred(r,r1))*Qkd(r,r1) ])
*Total capital income from non-super, non-dividend
                +(taxkg(r))* (sum[ r1 ,  (1-SupShare(r1))*(1-DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ])
*Total capital income from super, non-dividend
                +(taxsup(r))* (sum[ r1 ,  (SupShare(r1))*(1-DivShare(r1))*[Pkd(r,r1)-taxk(r,r1)]*Qkd(r,r1) ])
*Capital tax claimed on foreign capital domestically
                + (sum[ i1 , (taxK(i1,r))  *Qkd(i1,r) ])
*Credits for policy change
                - (sum[ r1 , -DivShare(r1)*(cred(r,r1))*Qkd(r,r1) ])
;


Model TimToTMCP /
  Eq_Cost0.Cost
*, Eq_QoS3.QoS3
, Eq_AggLab.QlD
, Eq_AggCap.QkD

, Eq_Cost1.Cost1
, Eq_Cost2.Cost2
, Eq_Cost3.Cost3
, Eq_XL.XL
, Eq_XRoW.XRow
, Eq_XAus.XAus
, Eq_XNzl.XNzl

*, Eq_QlD3.Qld
*, Eq_QkD3.Qkd


, Eq_PkD.PkD
, Eq_QkS.QkS
, Eq_QlS_F.PlD
, Eq_QoSTim.QoS

, Eq_PkSCET.PkS2

, Eq_QoD.QoD
, Eq_PoD.PoD
, Eq_YTim.Y
, Eq_YDTim.YD
, Eq_YGTim.YG
, Eq_PoSTim.PoS

* Accounting identities for Larry
*, Eq_Exports.Exports
*, Eq_Imports.Imports
*, Eq_TB.TB
*
*, Eq_CapIncRec.CapIncRec
*, Eq_CapIncPaid.CapIncPaid
*, Eq_CapTaxRec.CapTaxRec
*, Eq_CapTaxPaid.CapTaxPaid
*, Eq_FP.FP
*, Eq_GNI.GNI
*, Eq_LabInc.LabInc
*, Eq_DomCapInc.DomCapInc
*, Eq_ForCapInc.ForCapInc
*, Eq_TaxYInc.TaxYInc
*, Eq_TaxKInc.TaxKInc
*, Eq_GNE.GNE
*, Eq_DomCon.DomCon
*, Eq_ForCon.ForCon
/ ;

* tmurray
taxkg('nzl') = 0 ;
taxsup(r) = 0.15 ;
SupShare(r) = 0 ;


Qkd.lo(i,r) = 0.00001 ;
Qld.lo(r)   = 0.00001 ;
Cost.lo(r)  = 0.00001 ;
PkD.lo(i,r) = 0.00001 ;
PkS.lo(i,r) = 0.00001 ;
PlD.lo(r)   = 0.00001 ;
QoS.lo(c)   = 0.00001 ;
QoD.lo(r,c) = 0.00001 ;
Pu.lo(c)    = 0.00001 ;
PoD.lo(r,c) = 0.00001 ;
Y.lo(c)     = 0.00001 ;
PoS.lo(r)   = 0.00001 ;

Qkd.l(i,r) = qkbar(i,r) ;
Qld.l(r) = qlbar(r) ;
Cost.l(r) = cbar(r) ;
PkD.l(i,r) = pkbar(i,r) ;
PkS.l(i,r)   = 1 ;
PlD.l(r) = plbar(r) ;
QoS.l(c) = sum[ r , qcbar(r,c) ] ;
QoD.l(r,c) = qcbar(r,c) ;
Pu.l(c) = 1 ;
PoD.l(r,c) = pcbar(r,c) ;
Y.l(c) = ybar(c) ;
PoS.l(r) = 1 ;

Out.l(r)  = QoS.l(r) ;
PoS2.l(r) = PoS.l(r) ;





PoS.fx('RoW') = 1 ;
*PlD.fx('RoW') = 1 ;

set as / z1*z100 / ;
parameter acc(as,r) ;
parameter acc_b(as,r), acc_p(as,r), acc_c(as,r), acc_cr(as,r),
          acc_crb(as,r), acc_crp(as,r) ;
acc_b(as,r) = 0; acc_p(as,r) = 0; acc_c(as,r) = 0; acc_cr(as,r) = 0;
acc_crb(as,r) = 0; acc_crp(as,r) = 0;



Solve TimToTMCP using MCP ;
$include reportP
$include reportU
$include reportz
$include Account2.gms
acc_b(as,r) = acc(as,r) ;




set lo / DivAus, DivNzl, CETAus, CETNzl, RoWAus, RoWNzl, KAuNzl, KNzAus,
         AusrGDP, AusrGNI, AusnTax, NzlrGDP, NzlrGNI, NzlnTax / ;
parameter realGNI_b(r), realGDP_b(r), nomiRev_b(r),
          realGNI_p(r), realGDP_p(r), nomiRev_p(r),
          price_b(r), price_p(r);

realGNI_b(r) =
                         Y.l(r)
                         / ( PlD.l(r) * QlD.l(r) + sum[ i , PkD.l(i,r) * QkD.l(i,r) ] )
                         * (            QlD.l(r) + sum[ i ,              QkD.l(i,r) ] ) ;
realGDP_b(r) = QoS.l(r) ;
nomiRev_b(r) = acc('z8',r) + acc('z12',r) ;

price_b(r) = ( PlD.l(r) * QlD.l(r) + sum[ i , PkD.l(i,r) * QkD.l(i,r) ] ) / ( QlD.l(r) + sum[ i , QkD.l(i,r) ] ) ;

cred('aus','nzl') = -0.28 ;
cred('nzl','aus') = -0.30 ;

Solve TimToTMCP using MCP ;
$include reportP
$include reportU
$include reportz
$include Account2.gms
acc_p(as,r) = acc(as,r) ;

acc_c(as,r) = 1000*[acc_p(as,r) - acc_b(as,r)] ;

option acc_c:0 ;
display acc_c ;



set l / l1*l10 / ;
* Run a million times
*set l / l1*l000000 / ;

set bw /
        01credA, 04TTaxA, 05LabIA, 06PTKIA, 07rGDPA, 08InvIA, 09rGNIA, 11KAusA, 12KnzlA, 13KrowA
        01credN, 04TTaxN, 05LabIN, 06PTKIN, 07rGDPN, 08InvIN, 09rGNIN, 11KAusN, 12KnzlN, 13KrowN
       / ;
parameter loopout(l,lo) ;
parameter loopoutR(l,lo) ;
parameter loopoutBW(l,bw) ;

scalar temp ;
temp = 0 ;



loop( l ,

*Initialise to NZPC preferred cap data
  temp            = 1.28 ;
    vkbar('nzl','aus') = 1.102 + temp ; vkbar('row','aus') = 37.175 - temp ;
  temp            = 0.389;
    vkbar('aus','nzl') = 4.191 - temp ; vkbar('row','nzl') = 2.994 + temp ;
    vcbar('nzl','nzl') = vcbar('nzl','nzl') + 1.28/(1+tdk('nzl','aus')) ;  vcbar('nzl','row') = vcbar('nzl','row') - 1.28/(1+tdk('nzl','aus')) ;
    vcbar('aus','aus') = vcbar('aus','aus') - 0.389/(1+tdk('aus','nzl')) ; vcbar('aus','row') = vcbar('aus','row') + 0.389/(1+tdk('aus','nzl')) ;
$include Database.gms

  cred('aus','nzl') = 0 ;
  cred('nzl','aus') = 0 ;

  Solve TimToTMCP using MCP ;
$include reportP
$include reportU
$include reportz
$include account2.gms
acc_b(as,r) = acc(as,r) ;
price_b(r) = ( sum[ i , PoD.l(i,r) * QoD.l(i,r) ] ) / ( sum[ i , QoD.l(i,r) ] ) ;

* Vanzetti [start]: The first line will implement the Aus recognition of NZ credits scenario
* Vanzetti [start]: The first line will implement the NZ recognition of Aus credits scenario
* Vanzetti [start]: Both lines together will implement the MRIC scenario
  cred('aus','nzl') = -0.28 ;
*  cred('nzl','aus') = -0.30 ;
* Vanzetti [end]

$include Database.gms

  Solve TimToTMCP using MCP ;
$include reportP
$include reportU
$include reportz
$include account2.gms
acc_p(as,r) = acc(as,r) ;
price_p(r) = ( sum[ i , PoD.l(i,r) * QoD.l(i,r) ] ) / ( sum[ i , QoD.l(i,r) ] ) ;

  loopout(l,'DivAus')  = DivShare('Aus') ;
  loopout(l,'DivNzl')  = DivShare('Nzl') ;
  loopout(l,'CetAus')  = sCET('Aus') ;
  loopout(l,'CetNzl')  = sCET('Nzl') ;
  loopout(l,'RoWAus')  = sRoW('Aus') ;
  loopout(l,'RoWNzl')  = sRoW('Nzl') ;
  loopout(l,'KAuNzl')  = vkbar('aus','nzl') ;
  loopout(l,'KNzAus')  = vkbar('nzl','aus') ;
  loopout(l,'AusrGDP') = 1000*(acc_p('z63','Aus') - acc_b('z63','Aus')) ;
  loopout(l,'AusrGNI') = 1000*(acc_p('z16','Aus') - acc_b('z16','Aus')) ;
  loopout(l,'AusnTax') = 1000*(acc_p('z8','Aus') + acc_p('z12','Aus') - acc_b('z8','Aus') - acc_b('z12','Aus')) ;
  loopout(l,'NzlrGDP') = 1000*(acc_p('z63','Nzl') - acc_b('z63','Nzl')) ;
  loopout(l,'NzlrGNI') = 1000*(acc_p('z16','Nzl') - acc_b('z16','Nzl')) ;
  loopout(l,'NzlnTax') = 1000*(acc_p('z8','Nzl') + acc_p('z12','Nzl') - acc_b('z8','Nzl') - acc_b('z12','Nzl')) ;

  loopoutR(l,'DivAus')  = DivShare('Aus') ;
  loopoutR(l,'DivNzl')  = DivShare('Nzl') ;
  loopoutR(l,'CetAus')  = sCET('Aus') ;
  loopoutR(l,'CetNzl')  = sCET('Nzl') ;
  loopoutR(l,'RoWAus')  = sRoW('Aus') ;
  loopoutR(l,'RoWNzl')  = sRoW('Nzl') ;
  loopoutR(l,'KAuNzl')  = vkbar('aus','nzl') ;
  loopoutR(l,'KNzAus')  = vkbar('nzl','aus') ;
  loopoutR(l,'AusrGDP') = 1000*(acc_p('z63','Aus')/price_p('Aus') - acc_b('z63','Aus')/price_b('Aus')) ;
  loopoutR(l,'AusrGNI') = 1000*(acc_p('z16','Aus')/price_p('Aus') - acc_b('z16','Aus')/price_b('Aus')) ;
  loopoutR(l,'AusnTax') = 1000*(acc_p('z8','Aus')/price_p('Aus') + acc_p('z12','Aus')/price_p('Aus') - acc_b('z8','Aus')/price_b('Aus') - acc_b('z12','Aus')/price_b('Aus')) ;
  loopoutR(l,'NzlrGDP') = 1000*(acc_p('z63','Nzl')/price_p('Nzl') - acc_b('z63','Nzl')/price_b('Nzl')) ;
  loopoutR(l,'NzlrGNI') = 1000*(acc_p('z16','Nzl')/price_p('Nzl') - acc_b('z16','Nzl')/price_b('Nzl')) ;
  loopoutR(l,'NzlnTax') = 1000*(acc_p('z8','Nzl')/price_p('Nzl') + acc_p('z12','Nzl')/price_p('Nzl') - acc_b('z8','Nzl')/price_b('Nzl') - acc_b('z12','Nzl')/price_b('Nzl')) ;

* bw:aus
  loopoutBW(l,'01credA')  = 1000*(acc_p('z3','Aus')/price_p('Aus') - acc_b('z3','Aus')/price_b('Aus')) + 0.001 ;
  loopoutBW(l,'04TTaxA')  = 1000*(acc_p('z8','Aus')/price_p('Aus') + acc_p('z12','Aus')/price_p('Aus') - acc_b('z8','Aus')/price_b('Aus') - acc_b('z12','Aus')/price_b('Aus')) ;
  loopoutBW(l,'05LabIA')  = 1000*(acc_p('z1','Aus')/price_p('Aus') - acc_b('z1','Aus')/price_b('Aus')) ;
  loopoutBW(l,'06PTKIA')  = 1000*(acc_p('z2','Aus')/price_p('Aus') + acc_p('z3','Aus')/price_p('Aus') + acc_p('z4','Aus')/price_p('Aus') - acc_b('z2','Aus')/price_b('Aus') - acc_b('z3','Aus')/price_b('Aus') - acc_b('z4','Aus')/price_b('Aus')) ;
  loopoutBW(l,'07rGDPA')  = 1000*(acc_p('z63','Aus')/price_p('Aus') - acc_b('z63','Aus')/price_b('Aus')) ;
  loopoutBW(l,'09rGNIA')  = 1000*(acc_p('z16','Aus')/price_p('Aus') - acc_b('z16','Aus')/price_b('Aus')) ;
  loopoutBW(l,'08InvIA')  = loopoutBW(l,'09rGNIA') - loopoutBW(l,'07rGDPA') ;
  loopoutBW(l,'11KAusA')  = CO_Q('KAus','OAus')*1000 ;
  loopoutBW(l,'12KNzlA')  = CO_Q('KNzl','OAus')*1000 ;
  loopoutBW(l,'13KRowA')  = CO_Q('KRow','OAus')*1000 ;
* bw:nzl
  loopoutBW(l,'01credN')  = 1000*(acc_p('z3','Nzl')/price_p('Nzl') - acc_b('z3','Nzl')/price_b('Nzl')) + 0.001;
  loopoutBW(l,'04TTaxN')  = 1000*(acc_p('z8','Nzl')/price_p('Nzl') + acc_p('z12','Nzl')/price_p('Nzl') - acc_b('z8','Nzl')/price_b('Nzl') - acc_b('z12','Nzl')/price_b('Nzl')) ;
  loopoutBW(l,'05LabIN')  = 1000*(acc_p('z1','Nzl')/price_p('Nzl') - acc_b('z1','Nzl')/price_b('Nzl')) ;
  loopoutBW(l,'06PTKIN')  = 1000*(acc_p('z2','Nzl')/price_p('Nzl') + acc_p('z3','Nzl')/price_p('Nzl') + acc_p('z4','Nzl')/price_p('Nzl') - acc_b('z2','Nzl')/price_b('Nzl') - acc_b('z3','Nzl')/price_b('Nzl') - acc_b('z4','Nzl')/price_b('Nzl')) ;
  loopoutBW(l,'07rGDPN')  = 1000*(acc_p('z63','Nzl')/price_p('Nzl') - acc_b('z63','Nzl')/price_b('Nzl')) ;
  loopoutBW(l,'09rGNIN')  = 1000*(acc_p('z16','Nzl')/price_p('Nzl') - acc_b('z16','Nzl')/price_b('Nzl')) ;
  loopoutBW(l,'08InvIN')  = loopoutBW(l,'09rGNIN') - loopoutBW(l,'07rGDPN') ;
  loopoutBW(l,'11KAusN')  = CO_Q('KAus','ONzl')*1000 ;
  loopoutBW(l,'12KNzlN')  = CO_Q('KNzl','ONzl')*1000 ;
  loopoutBW(l,'13KRowN')  = CO_Q('KRow','ONzl')*1000 ;



  acc_c(as,r)  = 1000*[acc_p(as,r) - acc_b(as,r)] ;
  acc_cr(as,r) = 1000*[acc_p(as,r)/price_p(r) - acc_b(as,r)/price_b(r)] ;
  acc_crb(as,r) = [acc_b(as,r)/price_b(r)] + 0.001 ;
  acc_crp(as,r) = [acc_p(as,r)/price_p(r)] + 0.001 ;
  display acc_c ;
  display acc_cr ;




) ;

Option loopout:3 ;
Display loopout ;

Option loopoutR:3 ;
Display loopoutR ;

Option loopoutBW:3 ;
Display loopoutBW ;



* Vanzetti parameters (due to my terrible parameter naming)
Parameter Vanzetti_realtables(as,r), Vanzetti_loop_output_real(l,lo) ;
Vanzetti_realtables(as,r)       = acc_cr(as,r) ;
Vanzetti_loop_output_real(l,lo) = 0 ;
Vanzetti_loop_output_real(l,'AusrGDP') = loopoutR(l,'AusrGDP')  ;
Vanzetti_loop_output_real(l,'AusrGNI') = loopoutR(l,'AusrGNI')  ;
Vanzetti_loop_output_real(l,'AusnTax') = loopoutR(l,'AusnTax')  ;
Vanzetti_loop_output_real(l,'NzlrGDP') = loopoutR(l,'NzlrGDP')  ;
Vanzetti_loop_output_real(l,'NzlrGNI') = loopoutR(l,'NzlrGNI')  ;
Vanzetti_loop_output_real(l,'NzlnTax') = loopoutR(l,'NzlnTax')  ;


Option Vanzetti_realtables:0 ;
Option Vanzetti_loop_output_real:0 ;
Display Vanzetti_realtables, Vanzetti_loop_output_real ;