
acc(as,r) = 0 ;

*tmurray
* GNI GNE calculations
*Labour and land income accruing to households after taxb
acc('z1',r) = (1-taxy(r))*PlD.l(r)*Qld.l(r) ;
*Returns to domestically owned and used capital accruing to households after tax
acc('z2',r) = (1-taxy(r))*PkS2.l(r,r) * QkS.l(r,r) ;
*Imp credits
acc('z3',r) = sum[ i1 , -cred(r,i1) * DivShare(r) * QkS.l(r,i1) ] ;
*Returns to domestically owned capital used overseas accruing to households after tax
acc('z4',r) = (1-taxy(r))*sum[ i1$[ord(r) ne ord(i1)] , PkD.l(r,i1)*QkD.l(r,i1) - taxk(r,i1)*Qkd.l(r,i1) ] ;
*   used in Australia
acc('z5',r) = (1-taxy(r))*[PkD.l(r,'aus')*QkD.l(r,'aus') - taxk(r,'aus')*Qkd.l(r,'aus')]
            - (1-taxy(r))*[PkD.l('aus','aus')*QkD.l('aus','aus') - taxk('aus','aus')*Qkd.l('aus','aus')]$[ord(r) eq 1];
*   used in New Zealand
acc('z6',r) = (1-taxy(r))*[PkD.l(r,'nzl')*QkD.l(r,'nzl') - taxk(r,'nzl')*Qkd.l(r,'nzl')]
            - (1-taxy(r))*[PkD.l('nzl','nzl')*QkD.l('nzl','nzl') - taxk('nzl','nzl')*Qkd.l('nzl','nzl')]$[ord(r) eq 2];
*   used in the Rest of the World
acc('z7',r) = (1-taxy(r))*[PkD.l(r,'row')*QkD.l(r,'row') - taxk(r,'row')*Qkd.l(r,'row')]
            - (1-taxy(r))*[PkD.l('row','row')*QkD.l('row','row') - taxk('row','row')*Qkd.l('row','row')]$[ord(r) eq 3];
*   Total tax collected on personal income
acc('z9',r) = taxy(r)/(1-taxy(r))*[acc('z1',r)+acc('z2',r)+acc('z4',r)] ;
*   Credits granted for domestic company tax
acc('z10',r) = -tdk(r,r) * QkS.l(r,r) ;
*   Credits granted for foreign company tax
acc('z11',r) = -acc('z3',r) ;
*Taxes on personal income
acc('z8',r) = acc('z9',r) + acc('z10',r) + acc('z11',r) ;
*Company taxes levied on foreign capital used domestically
acc('z12',r) = sum[ i1 , tdk(i1,r) *  QkD.l(i1,r) ] ;
*   Australian owned
acc('z13',r) = tdk('Aus',r) *  QkD.l('Aus',r) ;
*   New Zealand owned
acc('z14',r) = tdk('Nzl',r) *  QkD.l('Nzl',r) ;
*   Rest of the World owned
acc('z15',r) = tdk('RoW',r) *  QkD.l('RoW',r) ;
*Gross National Income
acc('z16',r) = acc('z1',r) + acc('z2',r) + acc('z3',r) + acc('z4',r) + acc('z8',r) + acc('z12',r);

acc('z17',r) = 0.001 ;

*Consumption of domestic production
acc('z18',r) = PoD.l(r,r)*QoD.l(r,r) ;
*Consumption of imports
acc('z19',r) = sum[ r1 , PoD.l(r1,r)*QoD.l(r1,r) ] - acc('z18',r) ;
*   from Australia
acc('z20',r) = PoD.l('Aus',r)*QoD.l('Aus',r)$[ord(r) ne 1] ;
*   from New Zealand
acc('z21',r) = PoD.l('Nzl',r)*QoD.l('Nzl',r)$[ord(r) ne 2] ;
*   from the Rest of the World
acc('z22',r) = PoD.l('RoW',r)*QoD.l('RoW',r)$[ord(r) ne 3] ;
*Gross National Expenditure
acc('z23',r) = acc('z18',r) + acc('z19',r) ;

acc('z24',r) = 0.001 ;

*tmurray
* TB FP calculations
*Exports
acc('z25',r) = sum[ r1 , PoD.l(r,r1)*QoD.l(r,r1) ] - acc('z18',r) ;
*   to Australia
acc('z26',r) = PoD.l(r,'Aus')*QoD.l(r,'Aus')$[ord(r) ne 1] ;
*   to New Zealand
acc('z27',r) = PoD.l(r,'Nzl')*QoD.l(r,'Nzl')$[ord(r) ne 2] ;
*   to the Rest of the World
acc('z28',r) = PoD.l(r,'RoW')*QoD.l(r,'RoW')$[ord(r) ne 3] ;
*Imports
acc('z29',r) = sum[ r1 , PoD.l(r1,r)*QoD.l(r1,r) ] - acc('z18',r) ;
*   from Australia
acc('z30',r) = PoD.l('Aus',r)*QoD.l('Aus',r)$[ord(r) ne 1] ;
*   from New Zealand
acc('z31',r) = PoD.l('Nzl',r)*QoD.l('Nzl',r)$[ord(r) ne 2] ;
*   from the Rest of the World
acc('z32',r) = PoD.l('RoW',r)*QoD.l('RoW',r)$[ord(r) ne 3] ;
*Trade balance
acc('z33',r) = acc('z25',r) - acc('z29',r) ;

acc('z34',r) = 0.001 ;

*Capital income received from o/seas including foreign taxes
acc('z35',r) = sum[ r1$[ord(r1) ne ord(r)] , PkD.l(r,r1)*QkD.l(r,r1) ] ;
*   from Australia
acc('z36',r) = PkD.l(r,'Aus')*QkD.l(r,'Aus')$[ord(r) ne 1] ;
*   from New Zealand
acc('z37',r) = PkD.l(r,'Nzl')*QkD.l(r,'Nzl')$[ord(r) ne 2] ;
*   from the Rest of the World
acc('z38',r) = PkD.l(r,'RoW')*QkD.l(r,'RoW')$[ord(r) ne 3] ;
*Capital income paid to o/seas owners including domestic taxes
acc('z39',r) = sum[ r1$[ord(r1) ne ord(r)] , PkD.l(r1,r)*QkD.l(r1,r) ] ;
*   to Australia
acc('z40',r) = PkD.l('Aus',r)*QkD.l('Aus',r)$[ord(r) ne 1] ;
*   to New Zealand
acc('z41',r) = PkD.l('Nzl',r)*QkD.l('Nzl',r)$[ord(r) ne 2] ;
*   to the Rest of the World
acc('z42',r) = PkD.l('RoW',r)*QkD.l('RoW',r)$[ord(r) ne 3] ;
*Company tax collected from foreign-owned capital incomes earned domestically
acc('z43',r) = sum[ r1$[ord(r1) ne ord(r)] , tdk(r1,r)*QkD.l(r1,r) ] ;
*   Australian owned
acc('z44',r) = tdk('Aus',r)*QkD.l('Aus',r)$[ord(r) ne 1] ;
*   New Zealand owned
acc('z45',r) = tdk('Nzl',r)*QkD.l('Nzl',r)$[ord(r) ne 2] ;
*   Rest of the World owned
acc('z46',r) = tdk('RoW',r)*QkD.l('RoW',r)$[ord(r) ne 3] ;
*Company tax paid from domestically owned capital incomes earned overseas
acc('z47',r) = sum[ r1$[ord(r1) ne ord(r)] , tdk(r,r1)*QkD.l(r,r1) ] ;
*   in Australia
acc('z48',r) = tdk(r,'Aus')*QkD.l(r,'Aus')$[ord(r) ne 1] ;
*   in New Zealand
acc('z49',r) = tdk(r,'Nzl')*QkD.l(r,'Nzl')$[ord(r) ne 2] ;
*   in the Rest of the World
acc('z50',r) = tdk(r,'RoW')*QkD.l(r,'RoW')$[ord(r) ne 3] ;
*Total factor payments
acc('z51',r) = acc('z35',r) - acc('z39',r) + acc('z43',r) - acc('z47',r) ;

acc('z52',r) = 0.001 ;

*tmurray
* TB FP calculations
*Consumption, Investment, Government spending
acc('z53',r) = acc('z23',r) ;
*Exports
acc('z54',r) = acc('z25',r) ;
*Imports
acc('z55',r) = acc('z29',r) ;
*GDP (Expenditure side)
acc('z56',r) = acc('z53',r) + acc('z54',r) - acc('z55',r) ;

acc('z57',r) = 0.001 ;

*Specific factor income (including taxes)
acc('z58',r) = PlD.l(r)*Qld.l(r) ;
*Capital income (including taxes)
acc('z59',r) = sum[ i1 , PkD.l(i1,r)*Qkd.l(i1,r) ] ;
*   Australian owned
acc('z60',r) = PkD.l('Aus',r)*Qkd.l('Aus',r) ;
*   New Zealand owned
acc('z61',r) = PkD.l('Nzl',r)*Qkd.l('Nzl',r) ;
*   Rest of the World owned
acc('z62',r) = PkD.l('RoW',r)*Qkd.l('RoW',r) ;
*GDP (Income side)
acc('z63',r) = acc('z58',r) + acc('z59',r) ;



